mergetools/p4merge: create a base if none available
[git/git.git] / git-merge-one-file.sh
CommitLineData
839a7a06
LT
1#!/bin/sh
2#
ec73962d
PB
3# Copyright (c) Linus Torvalds, 2005
4#
5# This is the git per-file merge script, called with
839a7a06 6#
e3b4be7f
LT
7# $1 - original file SHA1 (or empty)
8# $2 - file in branch1 SHA1 (or empty)
9# $3 - file in branch2 SHA1 (or empty)
839a7a06 10# $4 - pathname in repository
82e5a82f 11# $5 - original file mode (or empty)
ee28152d
JH
12# $6 - file in branch1 mode (or empty)
13# $7 - file in branch2 mode (or empty)
839a7a06 14#
e3b4be7f 15# Handle some trivial cases.. The _really_ trivial cases have
5be60078 16# been handled already by git read-tree, but that one doesn't
ec73962d 17# do any merges that might change the tree layout.
0a9ea850 18
ae5bdda3
JN
19USAGE='<orig blob> <our blob> <their blob> <path>'
20USAGE="$USAGE <orig mode> <our mode> <their mode>"
21LONG_USAGE="Usage: git merge-one-file $USAGE
22
23Blob ids and modes should be empty for missing files."
24
6aaeca90
JK
25SUBDIRECTORY_OK=Yes
26. git-sh-setup
27cd_to_toplevel
28require_work_tree
29
ae5bdda3
JN
30if ! test "$#" -eq 7
31then
32 echo "$LONG_USAGE"
33 exit 1
34fi
35
e3b4be7f 36case "${1:-.}${2:-.}${3:-.}" in
839a7a06 37#
98a96b00 38# Deleted in both or deleted in one and unchanged in the other
839a7a06 39#
98a96b00 40"$1.." | "$1.$1" | "$1$1.")
cdcb0ed4
LT
41 if [ "$2" ]; then
42 echo "Removing $4"
ed93b449
JH
43 else
44 # read-tree checked that index matches HEAD already,
45 # so we know we do not have this path tracked.
46 # there may be an unrelated working tree file here,
561b0fbb
JH
47 # which we should just leave unmolested. Make sure
48 # we do not have it in the index, though.
49 exec git update-index --remove -- "$4"
cdcb0ed4 50 fi
0b124bb4 51 if test -f "$4"; then
397c7669 52 rm -f -- "$4" &&
f327dbce 53 rmdir -p "$(expr "z$4" : 'z\(.*\)/')" 2>/dev/null || :
aacc15ec 54 fi &&
5be60078 55 exec git update-index --remove -- "$4"
ec73962d
PB
56 ;;
57
839a7a06 58#
ee28152d 59# Added in one.
839a7a06 60#
ed93b449
JH
61".$2.")
62 # the other side did not add and we added so there is nothing
561b0fbb
JH
63 # to be done, except making the path merged.
64 exec git update-index --add --cacheinfo "$6" "$2" "$4"
ed93b449
JH
65 ;;
66"..$3")
98a96b00 67 echo "Adding $4"
29dc1331
JH
68 if test -f "$4"
69 then
ed93b449
JH
70 echo "ERROR: untracked $4 is overwritten by the merge."
71 exit 1
29dc1331 72 fi
561b0fbb 73 git update-index --add --cacheinfo "$7" "$3" "$4" &&
5be60078 74 exec git checkout-index -u -f -- "$4"
ec73962d
PB
75 ;;
76
e2b6a9d0 77#
f7d24bbe 78# Added in both, identically (check for same permissions).
e2b6a9d0 79#
ee28152d 80".$3$2")
e2b6a9d0 81 if [ "$6" != "$7" ]; then
ee28152d
JH
82 echo "ERROR: File $4 added identically in both branches,"
83 echo "ERROR: but permissions conflict $6->$7."
e2b6a9d0
JB
84 exit 1
85 fi
98a96b00 86 echo "Adding $4"
5be60078
JH
87 git update-index --add --cacheinfo "$6" "$2" "$4" &&
88 exec git checkout-index -u -f -- "$4"
ec73962d
PB
89 ;;
90
e3b4be7f 91#
ee28152d 92# Modified in both, but differently.
e3b4be7f 93#
f7d24bbe 94"$1$2$3" | ".$2$3")
54dd99a1
JH
95
96 case ",$6,$7," in
97 *,120000,*)
98 echo "ERROR: $4: Not merging symbolic link changes."
99 exit 1
100 ;;
ff72af00
JH
101 *,160000,*)
102 echo "ERROR: $4: Not merging conflicting submodule changes."
103 exit 1
104 ;;
54dd99a1
JH
105 esac
106
4549162e
KB
107 src1=$(git-unpack-file $2)
108 src2=$(git-unpack-file $3)
f7d24bbe
JH
109 case "$1" in
110 '')
111 echo "Added $4 in both, but differently."
4549162e
KB
112 orig=$(git-unpack-file $2)
113 create_virtual_base "$orig" "$src2"
f7d24bbe
JH
114 ;;
115 *)
31f883d1 116 echo "Auto-merging $4"
4549162e 117 orig=$(git-unpack-file $1)
f7d24bbe
JH
118 ;;
119 esac
ec73962d 120
b539c5e8
JH
121 # Be careful for funny filename such as "-L" in "$4", which
122 # would confuse "merge" greatly.
5be60078 123 git merge-file "$src1" "$orig" "$src2"
e2b6a9d0 124 ret=$?
718135e3
AR
125 msg=
126 if [ $ret -ne 0 ]; then
127 msg='content conflict'
128 fi
b539c5e8
JH
129
130 # Create the working tree file, using "our tree" version from the
131 # index, and then store the result of the merge.
6aaeca90 132 git checkout-index -f --stage=2 -- "$4" && cat "$src1" >"$4" || exit 1
b539c5e8 133 rm -f -- "$orig" "$src1" "$src2"
8544a6f1 134
e2b6a9d0 135 if [ "$6" != "$7" ]; then
718135e3
AR
136 if [ -n "$msg" ]; then
137 msg="$msg, "
138 fi
139 msg="${msg}permissions conflict: $5->$6,$7"
2a68a865 140 ret=1
e2b6a9d0 141 fi
f7d24bbe
JH
142 if [ "$1" = '' ]; then
143 ret=1
144 fi
8544a6f1 145
e2b6a9d0 146 if [ $ret -ne 0 ]; then
718135e3 147 echo "ERROR: $msg in $4"
0a9ea850
JB
148 exit 1
149 fi
5be60078 150 exec git update-index -- "$4"
ec73962d
PB
151 ;;
152
e3b4be7f 153*)
ec73962d
PB
154 echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
155 ;;
e3b4be7f
LT
156esac
157exit 1